local cached = false

// Run once to cache the whole font
hud.add(function(v,p,c)
	if cached then return end
	
	rawset(_G, "FONT_KART2", {monospace = 6})
	for i = 0,255 do
		local build = string.format("MKFT2%03d", i)
		if v.patchExists(build) then
			FONT_KART2[i] = v.cachePatch(build)
		end
	end
	
	cached = true
	
end, "game")


local styles = {
	"FS_SHADOW", // Draws another string right below this (useful for monocolor fonts)
	"FS_MONOSPACE", // Fixed width
	"FS_FIXED" // Enables scaling and places things in the fixed scale, epic!
}
for i = 1,#styles do
	rawset(_G, styles[i], 2^(i-1))
end

hud.add(function(v, p, c)
    if drawStringMkII return end
    
    rawset(_G, "drawStringMkII", function(x, y, str, font, flags, extra) // color, style, flags, align)
		local style,align,color,scale
		if extra ~= nil then
			color = extra.color
			style = extra.style
			//flags = extra.flags
			align = extra.align
			scale = extra.scale
		end
        //if str == "" then str = "-" end // Necessary even?
		if str == true then str = "true" end
		if str == false then str = "false" end
		if type(str) == "number" then str = tostring(str) end
		if type(str) ~= "string" then str = type(str) end
		
		if style == nil then style = 0 end
		if color == nil then color = 0 end
		if scale == nil then scale = FRACUNIT end
		
		if type(color) ~= "table" then
			color = {color}
		end
		
        local dt = {}
        local offset = 0
		local mono = font.monospace
        for i = 1,#str do
            local by = string.byte(str:sub(i,i))
            if font[by] ~= nil then
                dt[#dt+1] = {font[by], offset}
				local ew = font[by].width
				if (style & FS_MONOSPACE) then ew = mono end
				if (style & FS_FIXED) then ew = FixedMul(ew*FRACUNIT, scale) end
				-- FixedMul(ew*FRACUNIT, scale)
                offset = $ + ew
            else
				if (style & FS_FIXED) then mono = FixedMul(mono*FRACUNIT, scale) end
                offset = $ + mono
            end
        end

        local eo = 0
        if align == "center" then
            eo = offset/2
        end
        if align == "right" then
            eo = offset
        end
		
		local colormaps = {}
		for i = 1,#color do
			colormaps[i] = v.getColormap(-1, color[i])
		end
		
        for i = 1,#dt do
            local ix = dt[i]
			
			if (style & FS_SHADOW) then
				--v.draw(x+ix[2]-eo+1, y+1, ix[1], flags, colormaps[2])
			end
            --v.draw(x+ix[2]-eo, y, ix[1], flags, colormaps[1])
			if (style & FS_FIXED) then
				v.drawScaled(x+ix[2]-eo, y, scale, ix[1], flags, colormaps[1])
			else
				v.draw(x+ix[2]-eo, y, ix[1], flags, colormaps[1])
			end
			--v.drawScaled(x+ix[2]-eo, y, ix[1], flags, colormaps[1])
        end
    end)
end)